// SrvSna.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "ProtocolSna.h"
#include "ServiceSna.h"
#include "resource.h"
#include "protocolnone.h"
#include "ObjectFactory.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HINSTANCE g_hInstance = NULL;

static AFX_EXTENSION_MODULE SrvSnaDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("SRVSNA.DLL Initializing!\n");
		
		g_hInstance = hInstance;
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(SrvSnaDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(SrvSnaDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("SRVSNA.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(SrvSnaDLL);
	}
	return 1;   // ok
}

void APIENTRY DeleteObj(CConfigObject const ** const ppObj)
{
   TRACE("SRVSNA.DLL: DeleteObj()\n");

   try
   {
      AffirmThrow(ppObj != NULL);
      AffirmThrow(*ppObj != NULL);

      delete *ppObj;
      *ppObj = NULL;
   }
   catch (CAffirmException ae)
   {
   }

   return;
}

BOOL APIENTRY NewObj(CConfigObject const ** const ppObj, CString const & strName, HKEY const hKeyRoot, CString const & strRegPath, CConfigObject const * const pParent)
{
   BOOL fSuccess = FALSE;

   TRACE("SRVSNA.DLL: NewObj(%s)\n", (LPCTSTR)strName);

   CConfigObject * pNewObj = NULL;

   try
   {
      AffirmThrow(ppObj != NULL);
#if defined(_DEBUG)
      if (*ppObj != NULL) TRACE("*ppObj != NULL\n");
#endif

	  try
	  {
		  if (strName == DXB_REGVAL_PROTOCOL_ENUM_SNA)
		  {
			if (!CProtocolSna::IsSnaInstalled())
			{
				CString errmsg;
				errmsg.LoadString(IDS_SNAABSENT);
				AfxMessageBox(errmsg);
				AffirmThrow(FALSE);
			}
		    pNewObj = new CProtocolSna(hKeyRoot, strRegPath, pParent);
		  }

	  }
	  catch(CAffirmException ae)
	  {
	   if (pNewObj)
	   {
			DeleteObj((CConfigObject const ** const)&pNewObj);
			pNewObj = NULL;
	   }
       AffirmThrow(NewConfigObject(&pNewObj, CConfigObject::PROTOCOL, DXB_REGVAL_PROTOCOL_ENUM_NONE, hKeyRoot, strRegPath, pParent));

	  }
      if (strName != DXB_REGVAL_PROTOCOL_ENUM_SNA)
	  {
		if (strName == DXB_REGVAL_LINE_SERVICE_SNA) pNewObj = new CServiceSna(hKeyRoot, strRegPath, pParent);
		else AffirmThrow(FALSE);
	  }
      AffirmThrow(pNewObj != NULL);
	  fSuccess = TRUE;
     *ppObj  = pNewObj;
   }
   catch (CAffirmException ae)
   {
   }

   return fSuccess;
}

